/*
 * Grundkurs Informatik - Beispielprogramm zur LZW-Datenkompression
 * J. Schmidt, 2016
*/
#ifndef BYTEKETTE
#define BYTEKETTE

// Definition von bool für C90
typedef enum {false=0, true=1} bool;

typedef unsigned char t_byte;

// Datenstruktur für Zeichenketten
typedef struct
{
	t_byte *zeichen;         // Speicher für einzelne Bytes
	size_t anzZeichen;       // aktuell genutzte Anzahl an Bytes
	size_t maxAnzZeichen;    // Größe des aktuell reservierten Speicherplatzes
	size_t speicherBlockGroesse;  // Blockgröße, in denen Speicherplatz alloziert wird
} t_byte_kette;


void initByteKette(t_byte_kette *k);

void speicherAnlegenByteKette(t_byte_kette *k);

void speicherAnlegenFesteGroesseByteKette(t_byte_kette *k, size_t groesse);

void speicherFreigebenByteKette(t_byte_kette *k);

void speicherVergroessernByteKette(t_byte_kette *k);

void einzelZeichenAnhaengenByteKette(t_byte_kette *k, const t_byte zeichen);

// Setze Zeichenkette a = b
void ersetzenByteKette(t_byte_kette *a, const t_byte_kette b);

// Setze Zeichenkette a = b  (b ist ein einzelnes Zeichen)
void ersetzenByteKetteEinzel(t_byte_kette *a, const t_byte b);

// liefert true, wenn die beiden Strukturen die gleichen Zeichen enthalten
bool byteKettenIdentisch(const t_byte_kette a, const t_byte_kette b);

// printf für eine Zeichenkette
// nur druckbare Zeichen werden ausgegeben, andere durch "-" ersetzt
void printfByteKette(const t_byte_kette a);

// printf für eine Zeichenkette - rechtsbündig mit Länge laenge
// nur druckbare Zeichen werden ausgegeben, andere durch "-" ersetzt
void printfByteKetteRechts(const t_byte_kette a, unsigned int laenge);

#endif
